diff --git a/plugins/omprog/omprog.c b/plugins/omprog/omprog.c
index 2dbcc9988d..424c720dd7 100644
--- a/plugins/omprog/omprog.c
+++ b/plugins/omprog/omprog.c
@@ -37,10 +37,6 @@
 #include <unistd.h>
 #include <fcntl.h>
 #include <sys/wait.h>
-#if defined(__linux__) && defined(_GNU_SOURCE)
-#include <sys/syscall.h>
-#include <sys/types.h>
-#endif
 #include <pthread.h>
 #include "conf.h"
 #include "syslogd-types.h"
@@ -60,8 +56,7 @@ DEF_OMOD_STATIC_DATA
 DEFobjCurrIf(errmsg)
 
 #define NO_HUP_FORWARD -1	/* indicates that HUP should NOT be forwarded */
-/* linux specific: how long to wait for process to terminate gracefully before issuing SIGKILL */
-#define DEFAULT_FORCED_TERMINATION_TIMEOUT_MS 5000
+#define DEFAULT_CLOSE_TIMEOUT_MS 5000
 #define READLINE_BUFFER_SIZE 1024
 
 typedef struct _instanceData {
@@ -74,15 +69,17 @@ typedef struct _instanceData {
 	uchar *szBeginTransactionMark;	/* mark message for begin transaction */
 	uchar *szCommitTransactionMark;	/* mark message for commit transaction */
 	int bForceSingleInst;	/* only a single wrkr instance of program permitted? */
-	int iHUPForward;	/* signal to forward on HUP (or NO_HUP_FORWARD) */
-	int bSignalOnClose;	/* should signal process at shutdown */
+	int iHUPForward;		/* signal to forward on HUP (or NO_HUP_FORWARD) */
+	int bSignalOnClose;		/* should send SIGTERM to program before closing pipe? */
+	long lCloseTimeout;		/* how long to wait for program to terminate after closing pipe (ms) */
+	int bKillUnresponsive;	/* should send SIGKILL if closeTimeout is reached? */
 	uchar *outputFileName;	/* name of file to write the program output to, or NULL */
 	pthread_mutex_t mut;	/* make sure only one instance is active */
 } instanceData;
 
 typedef struct wrkrInstanceData {
 	instanceData *pData;
-	pid_t pid;		/* pid of currently running process */
+	pid_t pid;			/* pid of currently running process */
 	int fdPipeOut;		/* fd for sending messages to the program */
 	int fdPipeIn;		/* fd for receiving status messages from the program */
 	int fdPipeErr;		/* fd for receiving error output from the program */
@@ -107,7 +104,9 @@ static struct cnfparamdescr actpdescr[] = {
 	{ "forcesingleinstance", eCmdHdlrBinary, 0 },
 	{ "hup.signal", eCmdHdlrGetWord, 0 },
 	{ "template", eCmdHdlrGetWord, 0 },
-	{ "signalOnClose", eCmdHdlrBinary, 0 }
+	{ "signalOnClose", eCmdHdlrBinary, 0 },
+	{ "closeTimeout", eCmdHdlrGetWord, 0 },
+	{ "killUnresponsive", eCmdHdlrBinary, 0 }
 };
 
 static struct cnfparamblk actpblk =
@@ -183,7 +182,7 @@ execBinary(wrkrInstanceData_t *pWrkrData, int fdStdin, int fdStdout, int fdStder
 	sigAct.sa_handler = SIG_IGN;
 	sigaction(SIGINT, &sigAct, NULL);
 	sigemptyset(&set);
-        sigprocmask(SIG_SETMASK, &set, NULL);
+	sigprocmask(SIG_SETMASK, &set, NULL);
 
 	alarm(0);
 
@@ -361,153 +360,66 @@ checkProgramOutput(wrkrInstanceData_t *__restrict__ const pWrkrData)
 done:	return;
 }
 
-#if defined(__linux__) && defined(_GNU_SOURCE)
-typedef struct subprocess_timeout_desc_s {
-	pthread_attr_t thd_attr;
-	pthread_t thd;
-	pthread_mutex_t lock;
-	pthread_cond_t cond;
-	int timeout_armed;
-	pid_t waiter_tid;
-	long timeout_ms;
-	struct timespec timeout;
-} subprocess_timeout_desc_t;
-
-static void *
-killSubprocessOnTimeout(void *_subpTimeOut_p) {
-	subprocess_timeout_desc_t *subpTimeOut = (subprocess_timeout_desc_t *) _subpTimeOut_p;
-	if (pthread_mutex_lock(&subpTimeOut->lock) == 0) {
-		while (subpTimeOut->timeout_armed) {
-			int ret = pthread_cond_timedwait(&subpTimeOut->cond, &subpTimeOut->lock,
-				&subpTimeOut->timeout);
-			if (subpTimeOut->timeout_armed && ((ret == ETIMEDOUT) || (timeoutVal(&subpTimeOut->timeout)
-				== 0))) {
-				errmsg.LogError(0, RS_RET_CONC_CTRL_ERR, "omprog: child-process wasn't "
-					"reaped within timeout (%ld ms) preparing to force-kill.",
-					subpTimeOut->timeout_ms);
-				if (syscall(SYS_tgkill, getpid(), subpTimeOut->waiter_tid, SIGINT) != 0) {
-					errmsg.LogError(errno, RS_RET_SYS_ERR, "omprog: couldn't interrupt "
-						"thread(%d) which was waiting to reap child-process.",
-						subpTimeOut->waiter_tid);
-				}
-			}
-		}
-		pthread_mutex_unlock(&subpTimeOut->lock);
-	}
-	return NULL;
-}
-
-static rsRetVal
-setupSubprocessTimeout(subprocess_timeout_desc_t *subpTimeOut, long timeout_ms)
-{
-	int attr_initialized = 0, mutex_initialized = 0, cond_initialized = 0;
-	DEFiRet;
-
-	CHKiConcCtrl(pthread_attr_init(&subpTimeOut->thd_attr));
-	attr_initialized = 1;
-	CHKiConcCtrl(pthread_mutex_init(&subpTimeOut->lock, NULL));
-	mutex_initialized = 1;
-	CHKiConcCtrl(pthread_cond_init(&subpTimeOut->cond, NULL));
-	cond_initialized = 1;
-	/* mutex look to keep Coverity scan happen - not really necessary */
-	pthread_mutex_lock(&subpTimeOut->lock);
-	subpTimeOut->timeout_armed = 1;
-	subpTimeOut->waiter_tid = syscall(SYS_gettid);
-	subpTimeOut->timeout_ms = timeout_ms;
-	pthread_mutex_unlock(&subpTimeOut->lock);
-	CHKiRet(timeoutComp(&subpTimeOut->timeout, timeout_ms));
-	CHKiConcCtrl(pthread_create(&subpTimeOut->thd, &subpTimeOut->thd_attr, killSubprocessOnTimeout, subpTimeOut));
-finalize_it:
-	if (iRet != RS_RET_OK) {
-		if (attr_initialized) pthread_attr_destroy(&subpTimeOut->thd_attr);
-		if (mutex_initialized) pthread_mutex_destroy(&subpTimeOut->lock);
-		if (cond_initialized) pthread_cond_destroy(&subpTimeOut->cond);
-	}
-	RETiRet;
-}
-
-static void
-doForceKillSubprocess(subprocess_timeout_desc_t *subpTimeOut, int do_kill, pid_t pid)
-{
-	if (pthread_mutex_lock(&subpTimeOut->lock) == 0) {
-	        subpTimeOut->timeout_armed = 0;
-	        pthread_cond_signal(&subpTimeOut->cond);
-	        pthread_mutex_unlock(&subpTimeOut->lock);
-	}
-	pthread_join(subpTimeOut->thd, NULL);
-	if (do_kill) {
-		if (kill(pid, 9) == 0) {
-			errmsg.LogError(0, RS_RET_NO_ERRCODE, "omprog: child-process FORCE-killed");
-		} else {
-			errmsg.LogError(errno, RS_RET_SYS_ERR, "omprog: child-process cound't be FORCE-killed");
-		}
-	}
-	pthread_cond_destroy(&subpTimeOut->cond);
-	pthread_mutex_destroy(&subpTimeOut->lock);
-	pthread_attr_destroy(&subpTimeOut->thd_attr);
-}
-#endif
-
 static void
-waitForChild(wrkrInstanceData_t *pWrkrData, const long timeout_ms)
+waitForChild(wrkrInstanceData_t *pWrkrData)
 {
 	int status;
 	int ret;
+	long counter;
 
-#if defined(__linux__) && defined(_GNU_SOURCE)
-	subprocess_timeout_desc_t subpTimeOut;
-	int timeoutSetupStatus = 0;
-	int waitpid_interrupted;
-
-	if (timeout_ms > 0)
-		timeoutSetupStatus = setupSubprocessTimeout(&subpTimeOut, timeout_ms);
-#endif
+	counter = pWrkrData->pData->lCloseTimeout / 10;
+	while ((ret = waitpid(pWrkrData->pid, &status, WNOHANG)) == 0 && counter > 0) {
+		srSleep(0, 10000);  /* 0 seconds, 10 milliseconds */
+		--counter;
+	}
 
-	ret = waitpid(pWrkrData->pid, &status, 0);
+	if (ret == 0) {  /* timeout reached */
+		if (!pWrkrData->pData->bKillUnresponsive) {
+			errmsg.LogError(0, NO_ERRCODE, "omprog: program '%s' (pid %d) did not terminate "
+							"within timeout (%ld ms); ignoring it", pWrkrData->pData->szBinary,
+							pWrkrData->pid, pWrkrData->pData->lCloseTimeout);
+			return;
+		}
 
-#if defined(__linux__) && defined(_GNU_SOURCE)
-	waitpid_interrupted = (ret != pWrkrData->pid) && (errno == EINTR);
-	if ((timeout_ms > 0) && (timeoutSetupStatus == RS_RET_OK))
-		doForceKillSubprocess(&subpTimeOut, waitpid_interrupted, pWrkrData->pid);
-	if (waitpid_interrupted) {
-		waitForChild(pWrkrData, -1);
-		return;
+		errmsg.LogError(0, NO_ERRCODE, "omprog: program '%s' (pid %d) did not terminate "
+						"within timeout (%ld ms); killing it", pWrkrData->pData->szBinary,
+						pWrkrData->pid, pWrkrData->pData->lCloseTimeout);
+		if (kill(pWrkrData->pid, SIGKILL) == -1) {
+			errmsg.LogError(errno, RS_RET_SYS_ERR, "omprog: could not send SIGKILL to child process");
+			return;
+		}
+		ret = waitpid(pWrkrData->pid, &status, 0);
 	}
-#endif
 
-	if(ret != pWrkrData->pid) {
-		if (errno == ECHILD) {
-			errmsg.LogError(errno, RS_RET_OK_WARN, "Child %d doesn't seem to exist, "
-							"hence couldn't be reaped (reaped by main-loop?)",
-			pWrkrData->pid);
+	if (ret != pWrkrData->pid) {
+		if (errno == ECHILD) {  /* child reaped by the rsyslogd main loop (see rsyslogd.c) */
+			errmsg.LogError(0, NO_ERRCODE, "omprog: program '%s' (pid %d) exited; reaped by main loop",
+							pWrkrData->pData->szBinary, pWrkrData->pid);
 		} else {
-			errmsg.LogError(errno, RS_RET_SYS_ERR, "Cleanup failed for child %d", pWrkrData->pid);
+			errmsg.LogError(errno, RS_RET_SYS_ERR, "omprog: waitpid failed for program '%s' (pid %d)",
+							pWrkrData->pData->szBinary, pWrkrData->pid);
 		}
 	} else {
 		/* check if we should print out some diagnostic information */
-		DBGPRINTF("omprog: waitpid status return for program '%s': %2.2x\n",
-				  pWrkrData->pData->szBinary, status);
+		DBGPRINTF("omprog: waitpid status return for program '%s' (pid %d): %2.2x\n",
+				  pWrkrData->pData->szBinary, pWrkrData->pid, status);
 		if(WIFEXITED(status)) {
-			errmsg.LogError(0, NO_ERRCODE, "program '%s' exited normally, state %d",
-							pWrkrData->pData->szBinary, WEXITSTATUS(status));
+			errmsg.LogError(0, NO_ERRCODE, "omprog: program '%s' (pid %d) exited normally, status %d",
+							pWrkrData->pData->szBinary, pWrkrData->pid, WEXITSTATUS(status));
 		} else if(WIFSIGNALED(status)) {
-			errmsg.LogError(0, NO_ERRCODE, "program '%s' terminated by signal %d.",
-							pWrkrData->pData->szBinary, WTERMSIG(status));
+			errmsg.LogError(0, NO_ERRCODE, "omprog: program '%s' (pid %d) terminated by signal %d",
+							pWrkrData->pData->szBinary, pWrkrData->pid, WTERMSIG(status));
 		}
 	}
 }
 
-/* clean up the state after a terminated child
+/* close pipe and wait for child to terminate
  */
 static void
-cleanupChild(wrkrInstanceData_t *pWrkrData, long timeout_ms)
+cleanupChild(wrkrInstanceData_t *pWrkrData)
 {
 	assert(pWrkrData->bIsRunning == 1);
 
-	if(pWrkrData->pData->bSignalOnClose) {
-		waitForChild(pWrkrData, timeout_ms);
-	}
-
 	checkProgramOutput(pWrkrData);  /* try to catch any late messages */
 
 	if(pWrkrData->fdOutputFile != -1) {
@@ -526,11 +438,15 @@ cleanupChild(wrkrInstanceData_t *pWrkrData, long timeout_ms)
 		close(pWrkrData->fdPipeOut);
 		pWrkrData->fdPipeOut = -1;
 	}
+
+	/* wait for the child AFTER closing the pipe, so it receives EOF */
+	waitForChild(pWrkrData);
+
 	pWrkrData->bIsRunning = 0;
 }
 
-/* Send SIGTERM to child process (if configured to do so), wait for
- * termination, and clean up the state.
+/* Send SIGTERM to child process if configured to do so, close pipe
+ * and wait for child to terminate.
  */
 static void
 terminateChild(wrkrInstanceData_t *pWrkrData)
@@ -540,7 +456,8 @@ terminateChild(wrkrInstanceData_t *pWrkrData)
 	if (pWrkrData->pData->bSignalOnClose) {
 		kill(pWrkrData->pid, SIGTERM);
 	}
-	cleanupChild(pWrkrData, DEFAULT_FORCED_TERMINATION_TIMEOUT_MS);
+
+	cleanupChild(pWrkrData);
 }
 
 /* write to pipe
@@ -568,7 +485,7 @@ writePipe(wrkrInstanceData_t *pWrkrData, uchar *szMsg)
 				DBGPRINTF("omprog: program '%s' terminated, will be restarted\n",
 					  pWrkrData->pData->szBinary);
 				/* force restart in tryResume() */
-				cleanupChild(pWrkrData, 0);
+				cleanupChild(pWrkrData);
 			} else {
 				DBGPRINTF("omprog: error %d writing to pipe: %s\n", errno,
 					   rs_strerror_r(errno, errStr, sizeof(errStr)));
@@ -685,7 +602,7 @@ readPipe(wrkrInstanceData_t *pWrkrData)
 			DBGPRINTF("omprog: program '%s' terminated, will be restarted\n",
 				  pWrkrData->pData->szBinary);
 			/* force restart in tryResume() */
-			cleanupChild(pWrkrData, 0);
+			cleanupChild(pWrkrData);
 		} else {
 			DBGPRINTF("omprog: error %d reading from pipe: %s\n", errno,
 				   rs_strerror_r(errno, errStr, sizeof(errStr)));
@@ -861,6 +778,8 @@ setInstParamDefaults(instanceData *pData)
 	pData->bForceSingleInst = 0;
 	pData->iHUPForward = NO_HUP_FORWARD;
 	pData->bSignalOnClose = 0;
+	pData->lCloseTimeout = DEFAULT_CLOSE_TIMEOUT_MS;
+	pData->bKillUnresponsive = -1;  /* default value: bSignalOnClose */
 	pData->outputFileName = NULL;
 }
 
@@ -897,6 +816,10 @@ CODESTARTnewActInst
 			pData->bForceSingleInst = (int) pvals[i].val.d.n;
 		} else if(!strcmp(actpblk.descr[i].name, "signalOnClose")) {
 			pData->bSignalOnClose = (int) pvals[i].val.d.n;
+		} else if(!strcmp(actpblk.descr[i].name, "closeTimeout")) {
+			pData->lCloseTimeout = atol(es_str2cstr(pvals[i].val.d.estr, NULL));
+		} else if(!strcmp(actpblk.descr[i].name, "killUnresponsive")) {
+			pData->bKillUnresponsive = (int) pvals[i].val.d.n;
 		} else if(!strcmp(actpblk.descr[i].name, "hup.signal")) {
 			const char *const sig = es_str2cstr(pvals[i].val.d.estr, NULL);
 			if(!strcmp(sig, "HUP"))
@@ -925,7 +848,9 @@ CODESTARTnewActInst
 	CHKiRet(OMSRsetEntry(*ppOMSR, 0, (uchar*)strdup((pData->tplName == NULL) ?
 						"RSYSLOG_FileFormat" : (char*)pData->tplName),
 						OMSR_NO_RQD_TPL_OPTS));
-	DBGPRINTF("omprog: bForceSingleInst %d\n", pData->bForceSingleInst);
+	if (pData->bKillUnresponsive == -1) {
+		pData->bKillUnresponsive = pData->bSignalOnClose;  /* default value */
+	}
 CODE_STD_FINALIZERnewActInst
 	cnfparamvalsDestruct(pvals, &actpblk);
 ENDnewActInst
diff --git a/tests/Makefile.am b/tests/Makefile.am
index 5368efefa0..f203b38b60 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -448,33 +448,19 @@ TESTS +=  \
 endif
 
 if ENABLE_OMPROG
-# see https://github.com/rsyslog/rsyslog/issues/2403
-# TODO: re-enable!
-#	omprog-cleanup.sh
-#	omprog-noterm-cleanup.sh
-#	omprog-noterm-default.sh
-#	omprog-cleanup-with-outfile.sh
-# linux:
-#	omprog-noterm-unresponsive.sh
-# valgrind:
-#	omprog-noterm-cleanup-vg.sh
-#	omprog-cleanup-vg.sh
 TESTS +=  \
+	omprog-close-unresponsive.sh \
+	omprog-close-unresponsive-noterm.sh \
 	omprog-feedback.sh \
+	omprog-restart-terminated.sh \
+	omprog-restart-terminated-outfile.sh \
 	omprog-transactions.sh \
 	omprog-transactions-failed-messages.sh \
 	omprog-transactions-failed-commits.sh
-#if OS_LINUX
-#TESTS += \
-#	omprog-cleanup-when-unresponsive.sh
-#endif
 if HAVE_VALGRIND
 TESTS +=  \
-	omprog-multiparam-vg.sh
-#if OS_LINUX
-#TESTS += \
-	#omprog-cleanup-when-unresponsive-vg.sh
-#endif
+	omprog-multiparam-vg.sh \
+	omprog-restart-terminated-vg.sh
 endif
 endif
 
@@ -1377,33 +1363,26 @@ EXTRA_DIST= \
 	testsuites/action-tx-errfile.result \
 	pipeaction.sh \
 	testsuites/pipeaction.conf \
-	omprog-cleanup.sh \
-	omprog-cleanup-vg.sh \
-	omprog-cleanup-with-outfile.sh \
-	omprog-cleanup-when-unresponsive.sh \
-	omprog-cleanup-when-unresponsive-vg.sh \
-	omprog-noterm-cleanup.sh \
-	omprog-noterm-cleanup-vg.sh \
-	omprog-noterm-default.sh \
-	omprog-noterm-unresponsive.sh \
+	omprog-close-unresponsive.sh \
+	omprog-close-unresponsive-noterm.sh \
 	omprog-feedback.sh \
+	omprog-multiparam-vg.sh \
+	omprog-restart-terminated.sh \
+	omprog-restart-terminated-outfile.sh \
+	omprog-restart-terminated-vg.sh \
 	omprog-transactions.sh \
 	omprog-transactions-failed-messages.sh \
 	omprog-transactions-failed-commits.sh \
-	omprog-multiparam-vg.sh \
-	testsuites/omprog-cleanup.conf \
-	testsuites/omprog-noterm.conf \
-	testsuites/omprog-noterm-default.conf \
-	testsuites/omprog-noterm-unresponsive.conf \
-	testsuites/omprog-noterm.sh \
-	testsuites/omprog-cleanup-outfile.conf \
-	testsuites/omprog-cleanup-unresponsive.conf \
-	testsuites/omprog-test-bin.sh \
-	testsuites/term-ignoring-script.sh \
+	testsuites/omprog-close-unresponsive.conf \
+	testsuites/omprog-close-unresponsive-bin.sh \
+	testsuites/omprog-close-unresponsive-noterm.conf \
 	testsuites/omprog-feedback.conf \
 	testsuites/omprog-feedback-bin.sh \
-	testsuites/omprog-transactions-bin.sh \
+	testsuites/omprog-restart-terminated.conf \
+	testsuites/omprog-restart-terminated-bin.sh \
+	testsuites/omprog-restart-terminated-outfile.conf \
 	testsuites/omprog-transactions.conf \
+	testsuites/omprog-transactions-bin.sh \
 	testsuites/omprog-transactions-failed-messages.conf \
 	testsuites/omprog-transactions-failed-commits.conf \
 	pipe_noreader.sh \
diff --git a/tests/omprog-cleanup-vg.sh b/tests/omprog-cleanup-vg.sh
deleted file mode 100755
index a8e0c3d490..0000000000
--- a/tests/omprog-cleanup-vg.sh
+++ /dev/null
@@ -1,33 +0,0 @@
-#!/bin/bash
-# added 2016-09-20 by singh.janmejay
-# This file is part of the rsyslog project, released under ASL 2.0
-. $srcdir/diag.sh init
-. $srcdir/diag.sh check-command-available lsof
-
-. $srcdir/diag.sh startup-vg omprog-cleanup.conf
-. $srcdir/diag.sh wait-startup
-. $srcdir/diag.sh injectmsg  0 5
-. $srcdir/diag.sh wait-queueempty
-. $srcdir/diag.sh content-check "msgnum:00000000:"
-. $srcdir/diag.sh getpid
-
-old_fd_count=$(lsof -p $pid | wc -l)
-
-for i in $(seq 5 10); do
-    pkill -USR1 omprog-test-bin
-    sleep .1
-    . $srcdir/diag.sh injectmsg  $i 1
-    sleep .1
-done
-
-. $srcdir/diag.sh wait-queueempty
-. $srcdir/diag.sh content-check "msgnum:00000009:"
-
-new_fd_count=$(lsof -p $pid | wc -l)
-echo OLD: $old_fd_count NEW: $new_fd_count
-. $srcdir/diag.sh assert-equal $old_fd_count $new_fd_count 2
-
-. $srcdir/diag.sh shutdown-when-empty
-. $srcdir/diag.sh wait-shutdown-vg
-. $srcdir/diag.sh check-exit-vg
-. $srcdir/diag.sh exit
diff --git a/tests/omprog-cleanup-when-unresponsive-vg.sh b/tests/omprog-cleanup-when-unresponsive-vg.sh
deleted file mode 100755
index 4f44c6116c..0000000000
--- a/tests/omprog-cleanup-when-unresponsive-vg.sh
+++ /dev/null
@@ -1,22 +0,0 @@
-#!/bin/bash
-# added 2016-09-23 by singh.janmejay
-# This file is part of the rsyslog project, released under ASL 2.0
-echo ===============================================================================
-echo \[omprog-cleanup-when-unresponsive-vg.sh\]: test for cleanup in omprog when child-process is not responding with valgrind
-. $srcdir/diag.sh init
-. $srcdir/diag.sh startup-vg omprog-cleanup-unresponsive.conf
-. $srcdir/diag.sh wait-startup
-. $srcdir/diag.sh injectmsg  0 5
-sleep 1
-. $srcdir/diag.sh wait-queueempty
-. $srcdir/diag.sh content-check "msgnum:00000000:"
-. $srcdir/diag.sh getpid
-
-echo doing shutdown
-. $srcdir/diag.sh shutdown-when-empty
-echo wait on shutdown
-. $srcdir/diag.sh wait-shutdown-vg
-. $srcdir/diag.sh check-exit-vg
-. $srcdir/diag.sh content-check "received SIGTERM, ignoring it" #verify it actually received term
-. $srcdir/diag.sh ensure-no-process-exists term-ignoring-script.sh
-. $srcdir/diag.sh exit
diff --git a/tests/omprog-cleanup-when-unresponsive.sh b/tests/omprog-cleanup-when-unresponsive.sh
deleted file mode 100755
index 84ee705cdc..0000000000
--- a/tests/omprog-cleanup-when-unresponsive.sh
+++ /dev/null
@@ -1,20 +0,0 @@
-#!/bin/bash
-# added 2016-09-17 by singh.janmejay
-# This file is part of the rsyslog project, released under ASL 2.0
-echo ===============================================================================
-echo \[omprog-cleanup-when-unresponsive.sh\]: test for cleanup in omprog when child-process is not responding
-. $srcdir/diag.sh init
-. $srcdir/diag.sh startup omprog-cleanup-unresponsive.conf
-. $srcdir/diag.sh wait-startup
-. $srcdir/diag.sh injectmsg  0 5
-sleep 1
-. $srcdir/diag.sh wait-queueempty
-. $srcdir/diag.sh content-check "msgnum:00000000:"
-. $srcdir/diag.sh getpid
-
-echo doing shutdown
-. $srcdir/diag.sh shutdown-when-empty
-echo wait on shutdown
-. $srcdir/diag.sh wait-shutdown
-. $srcdir/diag.sh ensure-no-process-exists term-ignoring-script.sh
-. $srcdir/diag.sh exit
diff --git a/tests/omprog-cleanup-with-outfile.sh b/tests/omprog-cleanup-with-outfile.sh
deleted file mode 100755
index f04c131110..0000000000
--- a/tests/omprog-cleanup-with-outfile.sh
+++ /dev/null
@@ -1,34 +0,0 @@
-#!/bin/bash
-# added 2016-09-09 by singh.janmejay
-# This file is part of the rsyslog project, released under ASL 2.0
-. $srcdir/diag.sh init
-. $srcdir/diag.sh check-command-available lsof
-
-. $srcdir/diag.sh startup omprog-cleanup-outfile.conf
-. $srcdir/diag.sh wait-startup
-. $srcdir/diag.sh injectmsg  0 5
-. $srcdir/diag.sh wait-queueempty
-. $srcdir/diag.sh content-check "msgnum:00000000:"
-. $srcdir/diag.sh getpid
-
-old_fd_count=$(lsof -p $pid | wc -l)
-
-for i in $(seq 5 10); do
-    pkill -USR1 omprog-test-bin
-    sleep .1
-    . $srcdir/diag.sh injectmsg  $i 1
-    sleep .1
-done
-
-. $srcdir/diag.sh wait-queueempty
-. $srcdir/diag.sh content-check "msgnum:00000009:"
-
-new_fd_count=$(lsof -p $pid | wc -l)
-echo OLD: $old_fd_count NEW: $new_fd_count
-. $srcdir/diag.sh assert-equal $old_fd_count $new_fd_count 2
-
-cp rsyslog.out.log /tmp/
-
-. $srcdir/diag.sh shutdown-when-empty
-. $srcdir/diag.sh wait-shutdown
-. $srcdir/diag.sh exit
diff --git a/tests/omprog-cleanup.sh b/tests/omprog-cleanup.sh
deleted file mode 100755
index 918f6c6b1c..0000000000
--- a/tests/omprog-cleanup.sh
+++ /dev/null
@@ -1,32 +0,0 @@
-#!/bin/bash
-# added 2016-09-09 by singh.janmejay
-# This file is part of the rsyslog project, released under ASL 2.0
-. $srcdir/diag.sh init
-. $srcdir/diag.sh check-command-available lsof
-
-. $srcdir/diag.sh startup omprog-cleanup.conf
-. $srcdir/diag.sh wait-startup
-. $srcdir/diag.sh injectmsg  0 5
-. $srcdir/diag.sh wait-queueempty
-. $srcdir/diag.sh content-check "msgnum:00000000:"
-. $srcdir/diag.sh getpid
-
-old_fd_count=$(lsof -p $pid | wc -l)
-
-for i in $(seq 5 10); do
-    pkill -USR1 omprog-test-bin
-    sleep .1
-    . $srcdir/diag.sh injectmsg  $i 1
-    sleep .1
-done
-
-. $srcdir/diag.sh wait-queueempty
-. $srcdir/diag.sh content-check "msgnum:00000009:"
-
-new_fd_count=$(lsof -p $pid | wc -l)
-echo OLD: $old_fd_count NEW: $new_fd_count
-. $srcdir/diag.sh assert-equal $old_fd_count $new_fd_count 2
-
-. $srcdir/diag.sh shutdown-when-empty
-. $srcdir/diag.sh wait-shutdown
-. $srcdir/diag.sh exit
diff --git a/tests/omprog-close-unresponsive-noterm.sh b/tests/omprog-close-unresponsive-noterm.sh
new file mode 100755
index 0000000000..0dc1083272
--- /dev/null
+++ b/tests/omprog-close-unresponsive-noterm.sh
@@ -0,0 +1,37 @@
+#!/bin/bash
+# This file is part of the rsyslog project, released under ASL 2.0
+
+# This test checks that omprog does NOT send a TERM signal to the
+# external program when signalOnClose=off, closes the pipe, and kills
+# the unresponsive child if killUnresponsive=on.
+
+. $srcdir/diag.sh init
+. $srcdir/diag.sh startup omprog-close-unresponsive-noterm.conf
+. $srcdir/diag.sh wait-startup
+. $srcdir/diag.sh injectmsg 0 10
+. $srcdir/diag.sh wait-queueempty
+. $srcdir/diag.sh shutdown-when-empty
+. $srcdir/diag.sh wait-shutdown
+. $srcdir/diag.sh ensure-no-process-exists omprog-close-unresponsive-bin.sh
+
+expected_output="Starting
+Received msgnum:00000000:
+Received msgnum:00000001:
+Received msgnum:00000002:
+Received msgnum:00000003:
+Received msgnum:00000004:
+Received msgnum:00000005:
+Received msgnum:00000006:
+Received msgnum:00000007:
+Received msgnum:00000008:
+Received msgnum:00000009:
+Terminating unresponsively"
+
+written_output=$(<rsyslog.out.log)
+if [[ "$expected_output" != "$written_output" ]]; then
+    echo unexpected omprog script output:
+    echo "$written_output"
+    . $srcdir/diag.sh error-exit 1
+fi
+
+. $srcdir/diag.sh exit
diff --git a/tests/omprog-close-unresponsive.sh b/tests/omprog-close-unresponsive.sh
new file mode 100755
index 0000000000..7ced087720
--- /dev/null
+++ b/tests/omprog-close-unresponsive.sh
@@ -0,0 +1,38 @@
+#!/bin/bash
+# This file is part of the rsyslog project, released under ASL 2.0
+
+# This test checks that omprog sends a TERM signal to the external
+# program when signalOnClose=on, closes the pipe, and kills the
+# child if unresponsive.
+
+. $srcdir/diag.sh init
+. $srcdir/diag.sh startup omprog-close-unresponsive.conf
+. $srcdir/diag.sh wait-startup
+. $srcdir/diag.sh injectmsg 0 10
+. $srcdir/diag.sh wait-queueempty
+. $srcdir/diag.sh shutdown-when-empty
+. $srcdir/diag.sh wait-shutdown
+. $srcdir/diag.sh ensure-no-process-exists omprog-close-unresponsive-bin.sh
+
+expected_output="Starting
+Received msgnum:00000000:
+Received msgnum:00000001:
+Received msgnum:00000002:
+Received msgnum:00000003:
+Received msgnum:00000004:
+Received msgnum:00000005:
+Received msgnum:00000006:
+Received msgnum:00000007:
+Received msgnum:00000008:
+Received msgnum:00000009:
+Received SIGTERM
+Terminating unresponsively"
+
+written_output=$(<rsyslog.out.log)
+if [[ "$expected_output" != "$written_output" ]]; then
+    echo unexpected omprog script output:
+    echo "$written_output"
+    . $srcdir/diag.sh error-exit 1
+fi
+
+. $srcdir/diag.sh exit
diff --git a/tests/omprog-feedback.sh b/tests/omprog-feedback.sh
index 0a2b1931e8..b485450c70 100755
--- a/tests/omprog-feedback.sh
+++ b/tests/omprog-feedback.sh
@@ -1,8 +1,9 @@
 #!/bin/bash
 # This file is part of the rsyslog project, released under ASL 2.0
 
-echo ===============================================================================
-echo '[omprog-feedback.sh]: test omprog with confirmMessages flag enabled'
+# This test tests the feedback feature of omprog (confirmMessages=on),
+# by checking that omprog re-sends to the external program the messages
+# it has failed to process.
 
 . $srcdir/diag.sh init
 . $srcdir/diag.sh startup omprog-feedback.conf
diff --git a/tests/omprog-noterm-cleanup-vg.sh b/tests/omprog-noterm-cleanup-vg.sh
deleted file mode 100755
index 1fa7d66901..0000000000
--- a/tests/omprog-noterm-cleanup-vg.sh
+++ /dev/null
@@ -1,36 +0,0 @@
-#!/bin/bash
-# added 2016-11-03 by singh.janmejay
-# This file is part of the rsyslog project, released under ASL 2.0
-. $srcdir/diag.sh init
-. $srcdir/diag.sh check-command-available lsof
-
-. $srcdir/diag.sh startup-vg omprog-noterm.conf
-. $srcdir/diag.sh wait-startup
-. $srcdir/diag.sh injectmsg  0 5
-. $srcdir/diag.sh wait-queueempty
-. $srcdir/diag.sh content-check "msgnum:00000000:"
-. $srcdir/diag.sh getpid
-
-old_fd_count=$(lsof -p $pid | wc -l)
-
-for i in $(seq 5 10); do
-    pkill -USR1 omprog-noterm.sh
-    sleep .1
-    . $srcdir/diag.sh injectmsg  $i 1
-    sleep .1
-done
-
-. $srcdir/diag.sh wait-queueempty
-. $srcdir/diag.sh content-check "msgnum:00000009:"
-
-new_fd_count=$(lsof -p $pid | wc -l)
-echo OLD: $old_fd_count NEW: $new_fd_count
-. $srcdir/diag.sh assert-equal $old_fd_count $new_fd_count 2
-
-. $srcdir/diag.sh shutdown-when-empty
-. $srcdir/diag.sh wait-shutdown-vg
-. $srcdir/diag.sh check-exit-vg
-sleep 1
-. $srcdir/diag.sh assert-content-missing "received SIGTERM"
-. $srcdir/diag.sh content-check "PROCESS TERMINATED (last msg: Exit due to read-failure)"
-. $srcdir/diag.sh exit
diff --git a/tests/omprog-noterm-cleanup.sh b/tests/omprog-noterm-cleanup.sh
deleted file mode 100755
index 15c4fbdd76..0000000000
--- a/tests/omprog-noterm-cleanup.sh
+++ /dev/null
@@ -1,37 +0,0 @@
-#!/bin/bash
-# added 2016-11-03 by singh.janmejay
-# This file is part of the rsyslog project, released under ASL 2.0
-. $srcdir/diag.sh init
-. $srcdir/diag.sh check-command-available lsof
-
-. $srcdir/diag.sh startup omprog-noterm.conf
-. $srcdir/diag.sh wait-startup
-. $srcdir/diag.sh injectmsg  0 5
-. $srcdir/diag.sh wait-queueempty
-. $srcdir/diag.sh content-check "msgnum:00000000:"
-. $srcdir/diag.sh getpid
-
-old_fd_count=$(lsof -p $pid | wc -l)
-
-for i in $(seq 5 10); do
-    set -x
-    pkill -USR1 -f omprog-noterm.sh
-    set +x
-    sleep .1
-    . $srcdir/diag.sh injectmsg  $i 1
-    sleep .1
-done
-
-. $srcdir/diag.sh wait-queueempty
-. $srcdir/diag.sh content-check "msgnum:00000009:"
-
-new_fd_count=$(lsof -p $pid | wc -l)
-echo OLD: $old_fd_count NEW: $new_fd_count
-. $srcdir/diag.sh assert-equal $old_fd_count $new_fd_count 2
-
-. $srcdir/diag.sh shutdown-when-empty
-. $srcdir/diag.sh wait-shutdown
-sleep 1
-. $srcdir/diag.sh assert-content-missing "received SIGTERM"
-. $srcdir/diag.sh content-check "PROCESS TERMINATED (last msg: Exit due to read-failure)"
-. $srcdir/diag.sh exit
diff --git a/tests/omprog-noterm-default.sh b/tests/omprog-noterm-default.sh
deleted file mode 100755
index 84fd4a1dcb..0000000000
--- a/tests/omprog-noterm-default.sh
+++ /dev/null
@@ -1,29 +0,0 @@
-#!/bin/bash
-# added 2016-11-03 by singh.janmejay
-# This file is part of the rsyslog project, released under ASL 2.0
-echo ===============================================================================
-echo '[omprog-noterm-default.sh]: test for cleanup in omprog without SIGTERM with default (off) signalOnClose'
-
-uname
-if [ `uname` = "SunOS" ] ; then
-   echo "Solaris: FIX ME"
-   exit 77
-fi
-
-. $srcdir/diag.sh init
-. $srcdir/diag.sh startup omprog-noterm-default.conf
-. $srcdir/diag.sh wait-startup
-. $srcdir/diag.sh injectmsg  0 10
-sleep 1
-. $srcdir/diag.sh wait-queueempty
-sleep 1
-. $srcdir/diag.sh content-check "msgnum:00000009:"
-
-echo doing shutdown
-. $srcdir/diag.sh shutdown-when-empty
-echo wait on shutdown
-. $srcdir/diag.sh wait-shutdown
-sleep 1
-. $srcdir/diag.sh assert-content-missing "received SIGTERM"
-. $srcdir/diag.sh content-check "PROCESS TERMINATED (last msg: Exit due to read-failure)"
-. $srcdir/diag.sh exit
diff --git a/tests/omprog-noterm-unresponsive.sh b/tests/omprog-noterm-unresponsive.sh
deleted file mode 100755
index 8501d0e88d..0000000000
--- a/tests/omprog-noterm-unresponsive.sh
+++ /dev/null
@@ -1,24 +0,0 @@
-#!/bin/bash
-# added 2016-11-03 by singh.janmejay
-# This file is part of the rsyslog project, released under ASL 2.0
-echo ===============================================================================
-echo \[omprog-noterm-unresponsive.sh\]: ensure omprog script is cleanly orphaned when unresponsive if signalOnClose is disabled
-. $srcdir/diag.sh init
-. $srcdir/diag.sh startup omprog-noterm-unresponsive.conf
-. $srcdir/diag.sh wait-startup
-. $srcdir/diag.sh injectmsg  0 10
-. $srcdir/diag.sh wait-queueempty
-sleep 1
-. $srcdir/diag.sh content-check "msgnum:00000009:"
-
-echo doing shutdown
-. $srcdir/diag.sh shutdown-when-empty
-echo wait on shutdown
-. $srcdir/diag.sh wait-shutdown
-sleep 6
-. $srcdir/diag.sh assert-content-missing "received SIGTERM"
-. $srcdir/diag.sh assert-content-missing "PROCESS TERMINATED"
-pkill -USR1 omprog-test-bin
-sleep 1
-. $srcdir/diag.sh content-check "PROCESS TERMINATED"
-. $srcdir/diag.sh exit
diff --git a/tests/omprog-restart-terminated-outfile.sh b/tests/omprog-restart-terminated-outfile.sh
new file mode 100755
index 0000000000..be4bb6f91a
--- /dev/null
+++ b/tests/omprog-restart-terminated-outfile.sh
@@ -0,0 +1,84 @@
+#!/bin/bash
+# This file is part of the rsyslog project, released under ASL 2.0
+
+# Same test than 'omprog-restart-terminated.sh', using the 'outfile'
+# parameter.
+
+. $srcdir/diag.sh init
+. $srcdir/diag.sh check-command-available lsof
+
+. $srcdir/diag.sh startup omprog-restart-terminated-outfile.conf
+. $srcdir/diag.sh wait-startup
+. $srcdir/diag.sh injectmsg 0 1
+. $srcdir/diag.sh wait-queueempty
+
+. $srcdir/diag.sh getpid
+start_fd_count=$(lsof -p $pid | wc -l)
+
+. $srcdir/diag.sh injectmsg 1 1
+. $srcdir/diag.sh injectmsg 2 1
+. $srcdir/diag.sh wait-queueempty
+
+pkill -USR1 -f omprog-restart-terminated-bin.sh
+sleep .1
+
+. $srcdir/diag.sh injectmsg 3 1
+. $srcdir/diag.sh injectmsg 4 1
+. $srcdir/diag.sh wait-queueempty
+
+pkill -TERM -f omprog-restart-terminated-bin.sh
+sleep .1
+
+. $srcdir/diag.sh injectmsg 5 1
+. $srcdir/diag.sh injectmsg 6 1
+. $srcdir/diag.sh injectmsg 7 1
+. $srcdir/diag.sh wait-queueempty
+
+pkill -USR1 -f omprog-restart-terminated-bin.sh
+sleep .1
+
+. $srcdir/diag.sh injectmsg 8 1
+. $srcdir/diag.sh injectmsg 9 1
+. $srcdir/diag.sh wait-queueempty
+
+end_fd_count=$(lsof -p $pid | wc -l)
+
+. $srcdir/diag.sh shutdown-when-empty
+. $srcdir/diag.sh wait-shutdown
+
+expected_output="Starting
+Received msgnum:00000000:
+Received msgnum:00000001:
+Received msgnum:00000002:
+Received SIGUSR1, will terminate after the next message
+Received msgnum:00000003:
+Terminating without confirming the last message
+Starting
+Received msgnum:00000003:
+Received msgnum:00000004:
+Received SIGTERM, terminating
+Starting
+Received msgnum:00000005:
+Received msgnum:00000006:
+Received msgnum:00000007:
+Received SIGUSR1, will terminate after the next message
+Received msgnum:00000008:
+Terminating without confirming the last message
+Starting
+Received msgnum:00000008:
+Received msgnum:00000009:
+Terminating normally"
+
+written_output=$(<rsyslog.out.log)
+if [[ "$expected_output" != "$written_output" ]]; then
+    echo unexpected omprog script output:
+    echo "$written_output"
+    . $srcdir/diag.sh error-exit 1
+fi
+
+if [[ "$start_fd_count" != "$end_fd_count" ]]; then
+    echo file descriptor leak: started with $start_fd_count open files, ended with $end_fd_count 
+    . $srcdir/diag.sh error-exit 1
+fi
+
+. $srcdir/diag.sh exit
diff --git a/tests/omprog-restart-terminated-vg.sh b/tests/omprog-restart-terminated-vg.sh
new file mode 100755
index 0000000000..93aaeda3b0
--- /dev/null
+++ b/tests/omprog-restart-terminated-vg.sh
@@ -0,0 +1,84 @@
+#!/bin/bash
+# This file is part of the rsyslog project, released under ASL 2.0
+
+# Same test than 'omprog-restart-terminated.sh', with valgrind.
+
+. $srcdir/diag.sh init
+. $srcdir/diag.sh check-command-available lsof
+
+. $srcdir/diag.sh startup-vg omprog-restart-terminated.conf
+. $srcdir/diag.sh wait-startup
+. $srcdir/diag.sh injectmsg 0 1
+. $srcdir/diag.sh wait-queueempty
+
+. $srcdir/diag.sh getpid
+start_fd_count=$(lsof -p $pid | wc -l)
+
+. $srcdir/diag.sh injectmsg 1 1
+. $srcdir/diag.sh injectmsg 2 1
+. $srcdir/diag.sh wait-queueempty
+
+pkill -USR1 -f omprog-restart-terminated-bin.sh
+sleep .1
+
+. $srcdir/diag.sh injectmsg 3 1
+. $srcdir/diag.sh injectmsg 4 1
+. $srcdir/diag.sh wait-queueempty
+
+pkill -TERM -f omprog-restart-terminated-bin.sh
+sleep .1
+
+. $srcdir/diag.sh injectmsg 5 1
+. $srcdir/diag.sh injectmsg 6 1
+. $srcdir/diag.sh injectmsg 7 1
+. $srcdir/diag.sh wait-queueempty
+
+pkill -USR1 -f omprog-restart-terminated-bin.sh
+sleep .1
+
+. $srcdir/diag.sh injectmsg 8 1
+. $srcdir/diag.sh injectmsg 9 1
+. $srcdir/diag.sh wait-queueempty
+
+end_fd_count=$(lsof -p $pid | wc -l)
+
+. $srcdir/diag.sh shutdown-when-empty
+. $srcdir/diag.sh wait-shutdown-vg
+
+expected_output="Starting
+Received msgnum:00000000:
+Received msgnum:00000001:
+Received msgnum:00000002:
+Received SIGUSR1, will terminate after the next message
+Received msgnum:00000003:
+Terminating without confirming the last message
+Starting
+Received msgnum:00000003:
+Received msgnum:00000004:
+Received SIGTERM, terminating
+Starting
+Received msgnum:00000005:
+Received msgnum:00000006:
+Received msgnum:00000007:
+Received SIGUSR1, will terminate after the next message
+Received msgnum:00000008:
+Terminating without confirming the last message
+Starting
+Received msgnum:00000008:
+Received msgnum:00000009:
+Terminating normally"
+
+written_output=$(<rsyslog.out.log)
+if [[ "$expected_output" != "$written_output" ]]; then
+    echo unexpected omprog script output:
+    echo "$written_output"
+    . $srcdir/diag.sh error-exit 1
+fi
+
+if [[ "$start_fd_count" != "$end_fd_count" ]]; then
+    echo file descriptor leak: started with $start_fd_count open files, ended with $end_fd_count 
+    . $srcdir/diag.sh error-exit 1
+fi
+
+. $srcdir/diag.sh check-exit-vg
+. $srcdir/diag.sh exit
diff --git a/tests/omprog-restart-terminated.sh b/tests/omprog-restart-terminated.sh
new file mode 100755
index 0000000000..7b3b85682a
--- /dev/null
+++ b/tests/omprog-restart-terminated.sh
@@ -0,0 +1,88 @@
+#!/bin/bash
+# This file is part of the rsyslog project, released under ASL 2.0
+
+# This test checks that omprog restarts the external program when it
+# terminates prematurely, and that it does so without leaking fds.
+# Two cases are checked: termination of the program when omprog is
+# going to write to the pipe (to send a message to the program), and
+# when omprog is going to read from the pipe (when it is expecting
+# the program to confirm the last message).
+
+. $srcdir/diag.sh init
+. $srcdir/diag.sh check-command-available lsof
+
+. $srcdir/diag.sh startup omprog-restart-terminated.conf
+. $srcdir/diag.sh wait-startup
+. $srcdir/diag.sh injectmsg 0 1
+. $srcdir/diag.sh wait-queueempty
+
+. $srcdir/diag.sh getpid
+start_fd_count=$(lsof -p $pid | wc -l)
+
+. $srcdir/diag.sh injectmsg 1 1
+. $srcdir/diag.sh injectmsg 2 1
+. $srcdir/diag.sh wait-queueempty
+
+pkill -USR1 -f omprog-restart-terminated-bin.sh
+sleep .1
+
+. $srcdir/diag.sh injectmsg 3 1
+. $srcdir/diag.sh injectmsg 4 1
+. $srcdir/diag.sh wait-queueempty
+
+pkill -TERM -f omprog-restart-terminated-bin.sh
+sleep .1
+
+. $srcdir/diag.sh injectmsg 5 1
+. $srcdir/diag.sh injectmsg 6 1
+. $srcdir/diag.sh injectmsg 7 1
+. $srcdir/diag.sh wait-queueempty
+
+pkill -USR1 -f omprog-restart-terminated-bin.sh
+sleep .1
+
+. $srcdir/diag.sh injectmsg 8 1
+. $srcdir/diag.sh injectmsg 9 1
+. $srcdir/diag.sh wait-queueempty
+
+end_fd_count=$(lsof -p $pid | wc -l)
+
+. $srcdir/diag.sh shutdown-when-empty
+. $srcdir/diag.sh wait-shutdown
+
+expected_output="Starting
+Received msgnum:00000000:
+Received msgnum:00000001:
+Received msgnum:00000002:
+Received SIGUSR1, will terminate after the next message
+Received msgnum:00000003:
+Terminating without confirming the last message
+Starting
+Received msgnum:00000003:
+Received msgnum:00000004:
+Received SIGTERM, terminating
+Starting
+Received msgnum:00000005:
+Received msgnum:00000006:
+Received msgnum:00000007:
+Received SIGUSR1, will terminate after the next message
+Received msgnum:00000008:
+Terminating without confirming the last message
+Starting
+Received msgnum:00000008:
+Received msgnum:00000009:
+Terminating normally"
+
+written_output=$(<rsyslog.out.log)
+if [[ "$expected_output" != "$written_output" ]]; then
+    echo unexpected omprog script output:
+    echo "$written_output"
+    . $srcdir/diag.sh error-exit 1
+fi
+
+if [[ "$start_fd_count" != "$end_fd_count" ]]; then
+    echo file descriptor leak: started with $start_fd_count open files, ended with $end_fd_count 
+    . $srcdir/diag.sh error-exit 1
+fi
+
+. $srcdir/diag.sh exit
diff --git a/tests/omprog-transactions-failed-commits.sh b/tests/omprog-transactions-failed-commits.sh
index f43c213608..1153c2c681 100755
--- a/tests/omprog-transactions-failed-commits.sh
+++ b/tests/omprog-transactions-failed-commits.sh
@@ -1,10 +1,21 @@
 #!/bin/bash
 # This file is part of the rsyslog project, released under ASL 2.0
 
-echo ===============================================================================
-echo '[omprog-transactions-failed-commits.sh]: test omprog with confirmMessages and useTransactions flags enabled, with commit failures'
+# This test tests omprog with the confirmMessages=on and useTransactions=on
+# parameters, with the external program returning an error on certain
+# transaction commits.
 
 . $srcdir/diag.sh init
+
+uname
+if [ `uname` = "SunOS" ] ; then
+    # On Solaris, this test apparently reproduces bug #2356 (which probably
+    # was not fully corrected). Note this is a problem with the rsyslog core,
+    # not with the test. TODO: re-enable this test when the issue is corrected. 
+    echo "Solaris: FIX ME"
+    exit 77
+fi
+
 . $srcdir/diag.sh startup omprog-transactions-failed-commits.conf
 . $srcdir/diag.sh wait-startup
 
diff --git a/tests/omprog-transactions-failed-messages.sh b/tests/omprog-transactions-failed-messages.sh
index 5b96319b5e..6aa1ee18fa 100755
--- a/tests/omprog-transactions-failed-messages.sh
+++ b/tests/omprog-transactions-failed-messages.sh
@@ -1,13 +1,11 @@
 #!/bin/bash
 # This file is part of the rsyslog project, released under ASL 2.0
-. $srcdir/diag.sh init
 
-uname
-if [ `uname` = "SunOS" ] ; then
-   echo "Solaris: FIX ME"
-   exit 77
-fi
+# This test tests omprog with the confirmMessages=on and useTransactions=on
+# parameters, with the external program returning an error on certain
+# messages.
 
+. $srcdir/diag.sh init
 . $srcdir/diag.sh startup omprog-transactions-failed-messages.conf
 . $srcdir/diag.sh wait-startup
 
diff --git a/tests/omprog-transactions.sh b/tests/omprog-transactions.sh
index 44a2a52347..91a3df6af6 100755
--- a/tests/omprog-transactions.sh
+++ b/tests/omprog-transactions.sh
@@ -1,8 +1,9 @@
 #!/bin/bash
 # This file is part of the rsyslog project, released under ASL 2.0
 
-echo ===============================================================================
-echo '[omprog-transactions.sh]: test omprog with confirmMessages and useTransactions flags enabled'
+# This test tests omprog with the confirmMessages=on and useTransactions=on
+# parameters, with the external program successfully confirming all messages
+# and transactions.
 
 . $srcdir/diag.sh init
 . $srcdir/diag.sh startup omprog-transactions.conf
diff --git a/tests/testsuites/omprog-cleanup-outfile.conf b/tests/testsuites/omprog-cleanup-outfile.conf
deleted file mode 100644
index b4d0ca1b96..0000000000
--- a/tests/testsuites/omprog-cleanup-outfile.conf
+++ /dev/null
@@ -1,7 +0,0 @@
-$IncludeConfig diag-common.conf
-
-module(load="../plugins/omprog/.libs/omprog")
-
-template(name="outfmt" type="string" string="%msg%\n")
-
-action(type="omprog" binary="./testsuites/omprog-test-bin.sh" template="outfmt" output="./rsyslog.omprog.out.log" signalOnClose="on")
diff --git a/tests/testsuites/omprog-cleanup-unresponsive.conf b/tests/testsuites/omprog-cleanup-unresponsive.conf
deleted file mode 100644
index 13f187c71e..0000000000
--- a/tests/testsuites/omprog-cleanup-unresponsive.conf
+++ /dev/null
@@ -1,8 +0,0 @@
-$IncludeConfig diag-common.conf
-
-module(load="../plugins/omprog/.libs/omprog")
-
-template(name="outfmt" type="string" string="%msg%\n")
-
-action(type="omprog" binary="./testsuites/term-ignoring-script.sh" template="outfmt" signalOnClose="on")
-
diff --git a/tests/testsuites/omprog-cleanup.conf b/tests/testsuites/omprog-cleanup.conf
deleted file mode 100644
index 0c67256c42..0000000000
--- a/tests/testsuites/omprog-cleanup.conf
+++ /dev/null
@@ -1,8 +0,0 @@
-$IncludeConfig diag-common.conf
-
-module(load="../plugins/omprog/.libs/omprog")
-
-template(name="outfmt" type="string" string="%msg%\n")
-
-action(type="omprog" binary="./testsuites/omprog-test-bin.sh" template="outfmt" name="omprog_action" signalOnClose="on")
-
diff --git a/tests/testsuites/omprog-close-unresponsive-bin.sh b/tests/testsuites/omprog-close-unresponsive-bin.sh
new file mode 100755
index 0000000000..ea13b43e4a
--- /dev/null
+++ b/tests/testsuites/omprog-close-unresponsive-bin.sh
@@ -0,0 +1,28 @@
+#!/bin/bash
+
+outfile=rsyslog.out.log
+
+function handle_sigterm {
+    echo "Received SIGTERM" >> $outfile
+}
+trap "handle_sigterm" SIGTERM
+
+echo "Starting" >> $outfile
+
+# Tell rsyslog we are ready to start processing messages
+echo "OK"
+
+read log_line
+while [[ -n "$log_line" ]]; do
+    echo "Received $log_line" >> $outfile
+
+    # Tell rsyslog we are ready to process the next message
+    echo "OK"
+
+    read log_line
+done
+
+echo "Terminating unresponsively" >> $outfile
+sleep 5m
+
+exit 0
diff --git a/tests/testsuites/omprog-close-unresponsive-noterm.conf b/tests/testsuites/omprog-close-unresponsive-noterm.conf
new file mode 100644
index 0000000000..f1d7e917bf
--- /dev/null
+++ b/tests/testsuites/omprog-close-unresponsive-noterm.conf
@@ -0,0 +1,23 @@
+$IncludeConfig diag-common.conf
+
+module(load="../plugins/omprog/.libs/omprog")
+
+template(name="outfmt" type="string" string="%msg%\n")
+
+main_queue(
+    queue.timeoutShutdown="60000"  # give time to omprog to wait for the child
+)
+
+:msg, contains, "msgnum:" {
+    action(
+        type="omprog"
+        binary="./testsuites/omprog-close-unresponsive-bin.sh"
+        template="outfmt"
+        name="omprog_action"
+        queue.type="Direct"  # the default; facilitates sync with the child process
+        confirmMessages="on"  # facilitates sync with the child process
+        signalOnClose="off"
+        closeTimeout="1000"  # ms
+        killUnresponsive="on"  # default value: the value of signalOnClose
+    )
+}
diff --git a/tests/testsuites/omprog-close-unresponsive.conf b/tests/testsuites/omprog-close-unresponsive.conf
new file mode 100644
index 0000000000..c8f0a11725
--- /dev/null
+++ b/tests/testsuites/omprog-close-unresponsive.conf
@@ -0,0 +1,23 @@
+$IncludeConfig diag-common.conf
+
+module(load="../plugins/omprog/.libs/omprog")
+
+template(name="outfmt" type="string" string="%msg%\n")
+
+main_queue(
+    queue.timeoutShutdown="60000"  # give time to omprog to wait for the child
+)
+
+:msg, contains, "msgnum:" {
+    action(
+        type="omprog"
+        binary="./testsuites/omprog-close-unresponsive-bin.sh"
+        template="outfmt"
+        name="omprog_action"
+        queue.type="Direct"  # the default; facilitates sync with the child process
+        confirmMessages="on"  # facilitates sync with the child process
+        signalOnClose="on"
+        closeTimeout="1000"  # ms
+        #killUnresponsive="on"  # default value: the value of signalOnClose
+    )
+}
diff --git a/tests/testsuites/omprog-noterm-default.conf b/tests/testsuites/omprog-noterm-default.conf
deleted file mode 100644
index ef8f18c541..0000000000
--- a/tests/testsuites/omprog-noterm-default.conf
+++ /dev/null
@@ -1,8 +0,0 @@
-$IncludeConfig diag-common.conf
-
-module(load="../plugins/omprog/.libs/omprog")
-
-template(name="outfmt" type="string" string="%msg%\n")
-
-action(type="omprog" binary="./testsuites/omprog-noterm.sh" template="outfmt" name="omprog_action")
-
diff --git a/tests/testsuites/omprog-noterm-unresponsive.conf b/tests/testsuites/omprog-noterm-unresponsive.conf
deleted file mode 100644
index 21cf96fbda..0000000000
--- a/tests/testsuites/omprog-noterm-unresponsive.conf
+++ /dev/null
@@ -1,8 +0,0 @@
-$IncludeConfig diag-common.conf
-
-module(load="../plugins/omprog/.libs/omprog")
-
-template(name="outfmt" type="string" string="%msg%\n")
-
-action(type="omprog" binary="./testsuites/omprog-test-bin.sh" template="outfmt" name="omprog_action" signalOnClose="off")
-
diff --git a/tests/testsuites/omprog-noterm.conf b/tests/testsuites/omprog-noterm.conf
deleted file mode 100644
index dc697c4365..0000000000
--- a/tests/testsuites/omprog-noterm.conf
+++ /dev/null
@@ -1,8 +0,0 @@
-$IncludeConfig diag-common.conf
-
-module(load="../plugins/omprog/.libs/omprog")
-
-template(name="outfmt" type="string" string="%msg%\n")
-
-action(type="omprog" binary="./testsuites/omprog-noterm.sh" template="outfmt" name="omprog_action" signalOnClose="off")
-
diff --git a/tests/testsuites/omprog-noterm.sh b/tests/testsuites/omprog-noterm.sh
deleted file mode 100755
index 46ab86eda4..0000000000
--- a/tests/testsuites/omprog-noterm.sh
+++ /dev/null
@@ -1,27 +0,0 @@
-#!/bin/bash
-
-export loop_monitor=.loop_monitor
-touch $loop_monitor
-outfile=rsyslog.out.log
-
-trap "rm $loop_monitor" SIGUSR1
-
-function print_sigterm_receipt {
-    echo 'received SIGTERM' >> $outfile
-}
-trap "print_sigterm_receipt" SIGTERM
-
-while [ -e  $loop_monitor ]; do
-    read log_line
-    if [ "x$log_line" == "x" ]; then
-	log_line='Exit due to read-failure'
-	rm $loop_monitor
-    fi
-    echo $log_line >> $outfile
-done
-
-sleep .2 # so we can catch a TERM and log it, in case it comes (negative test for signalOnClose=off)
-
-echo "PROCESS TERMINATED (last msg: $log_line)" >> $outfile
-
-exit 0
diff --git a/tests/testsuites/omprog-restart-terminated-bin.sh b/tests/testsuites/omprog-restart-terminated-bin.sh
new file mode 100755
index 0000000000..68e40b48d8
--- /dev/null
+++ b/tests/testsuites/omprog-restart-terminated-bin.sh
@@ -0,0 +1,40 @@
+#!/bin/bash
+
+outfile=rsyslog.out.log
+terminate=false
+
+function handle_sigusr1 {
+    echo "Received SIGUSR1, will terminate after the next message" >> $outfile
+    terminate=true
+}
+trap "handle_sigusr1" SIGUSR1
+
+function handle_sigterm {
+    echo "Received SIGTERM, terminating" >> $outfile
+    exit 1
+}
+trap "handle_sigterm" SIGTERM
+
+echo "Starting" >> $outfile
+
+# Tell rsyslog we are ready to start processing messages
+echo "OK"
+
+read log_line
+while [[ -n "$log_line" ]]; do
+    echo "Received $log_line" >> $outfile
+
+    if [[ $terminate == true ]]; then
+        # Terminate prematurely by closing pipe, without confirming the message
+        echo "Terminating without confirming the last message" >> $outfile
+        exit 1
+    fi
+
+    # Tell rsyslog we are ready to process the next message
+    echo "OK"
+
+    read log_line
+done
+
+echo "Terminating normally" >> $outfile
+exit 0
diff --git a/tests/testsuites/omprog-restart-terminated-outfile.conf b/tests/testsuites/omprog-restart-terminated-outfile.conf
new file mode 100644
index 0000000000..2e13089667
--- /dev/null
+++ b/tests/testsuites/omprog-restart-terminated-outfile.conf
@@ -0,0 +1,21 @@
+$IncludeConfig diag-common.conf
+
+module(load="../plugins/omprog/.libs/omprog")
+
+template(name="outfmt" type="string" string="%msg%\n")
+
+:msg, contains, "msgnum:" {
+    action(
+        type="omprog"
+        binary="./testsuites/omprog-restart-terminated-bin.sh"
+        template="outfmt"
+        name="omprog_action"
+        queue.type="Direct"  # the default; facilitates sync with the child process
+        confirmMessages="on"  # facilitates sync with the child process
+        action.resumeRetryCount="10"
+        action.resumeInterval="1"
+        action.reportSuspensionContinuation="on"
+        signalOnClose="off"
+        output="./rsyslog.omprog.out.log"
+    )
+}
diff --git a/tests/testsuites/omprog-restart-terminated.conf b/tests/testsuites/omprog-restart-terminated.conf
new file mode 100644
index 0000000000..5c813eed59
--- /dev/null
+++ b/tests/testsuites/omprog-restart-terminated.conf
@@ -0,0 +1,20 @@
+$IncludeConfig diag-common.conf
+
+module(load="../plugins/omprog/.libs/omprog")
+
+template(name="outfmt" type="string" string="%msg%\n")
+
+:msg, contains, "msgnum:" {
+    action(
+        type="omprog"
+        binary="./testsuites/omprog-restart-terminated-bin.sh"
+        template="outfmt"
+        name="omprog_action"
+        queue.type="Direct"  # the default; facilitates sync with the child process
+        confirmMessages="on"  # facilitates sync with the child process
+        action.resumeRetryCount="10"
+        action.resumeInterval="1"
+        action.reportSuspensionContinuation="on"
+        signalOnClose="off"
+    )
+}
diff --git a/tests/testsuites/omprog-test-bin.sh b/tests/testsuites/omprog-test-bin.sh
deleted file mode 100755
index 7bab5f8f66..0000000000
--- a/tests/testsuites/omprog-test-bin.sh
+++ /dev/null
@@ -1,22 +0,0 @@
-#!/bin/bash
-
-export loop_monitor=.loop_monitor
-touch $loop_monitor
-outfile=rsyslog.out.log
-
-trap "rm $loop_monitor" SIGUSR1
-
-function print_sigterm_receipt {
-    echo 'received SIGTERM' >> $outfile
-    exit
-}
-trap "print_sigterm_receipt" SIGTERM
-
-while [ -e  $loop_monitor ]; do
-    read log_line
-    if [ "x$log_line" != "x" ]; then
-	echo $log_line >> $outfile
-    fi
-done
-
-echo "PROCESS TERMINATED" >> $outfile
diff --git a/tests/testsuites/term-ignoring-script.sh b/tests/testsuites/term-ignoring-script.sh
deleted file mode 100755
index 177b526382..0000000000
--- a/tests/testsuites/term-ignoring-script.sh
+++ /dev/null
@@ -1,19 +0,0 @@
-#!/bin/bash
-
-set -x
-
-export loop_monitor=.loop_monitor
-touch $loop_monitor
-outfile=rsyslog.out.log
-
-trap "rm $loop_monitor" SIGUSR1
-
-function print_sigterm_receipt {
-    echo 'received SIGTERM, ignoring it' >> $outfile
-}
-trap "print_sigterm_receipt" SIGTERM
-
-while [ -e  $loop_monitor ]; do
-    read log_line
-    echo $log_line >> $outfile
-done
